library ChildDLL;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Forms,
  Types,
  Classes, Windows, Dialogs,
  UnitDLLForm1 in 'UnitDLLForm1.pas' {Form1};

{$R *.res}

function SetParent(hWndChild: HWnd; hWndNewParent: HWnd):HWnd;
  stdcall; external 'user32.dll' name 'SetParent';

function CreateCustomWindow(ParentHandle:integer;
       DataRect:TRect; var WinHandle:THandle):integer;
        stdcall; export;
//   , 
//   
var
  FD:TForm1;
begin
  Result := 0;
  WinHandle := 0;
  try
    FD := TForm1.Create(nil);
    Result := integer(FD);
    WinHandle := FD.Handle;
    if ParentHandle<>0 then begin
      SetParent(WinHandle,ParentHandle);
      with FD do begin
        SetWindowPos(Handle, HWND_TOP, DataRect.Left,
        DataRect.Top, DataRect.Right-DataRect.Left,
        DataRect.Bottom-DataRect.Top, SWP_SHOWWINDOW);
        Show;
      end;
    end;
  except
    On E:exception do
    MessageDlg(E.Message,mtError,[mbOK],0);
  end;
end;

procedure DeleteCustomWindow(WinID:integer); stdcall; export;
begin
  try
    if WinID<>0 then TForm1(WinID).Free;
  except
    On E:exception do
    MessageDlg(E.Message,mtError,[mbOK],0);
  end;
end;

exports
  CreateCustomWindow,
  DeleteCustomWindow;
begin
end.
